| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
ComponentManager Class Reference

Base class for a component manager. More...

`#include <GaudiKernel/ComponentManager.h>`

Inheritance diagram for ComponentManager:
[legend]
Collaboration diagram for ComponentManager:
[legend]

## Public Member Functions
| ComponentManager (IInterface *application, const InterfaceID &baseIID)
| Constructor. More...
const InterfaceID & | componentBaseInterface () const override
| Basic interface id of the managed components. More...
| ~ComponentManager () override=default
| Virtual destructor. More...
StatusCode | queryInterface (const InterfaceID &iid, void **pinterface) override
| Specialized queryInterface implementation. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
StatusCode | configure () override
| Configuration (from OFFLINE to CONFIGURED). More...
StatusCode | initialize () override
| Initialization (from CONFIGURED to INITIALIZED). More...
StatusCode | start () override
| Start (from INITIALIZED to RUNNING). More...
StatusCode | stop () override
| Stop (from RUNNING to INITIALIZED). More...
StatusCode | finalize () override
| Finalize (from INITIALIZED to CONFIGURED). More...
StatusCode | terminate () override
| Initialization (from CONFIGURED to OFFLINE). More...
StatusCode | reinitialize () override
| Initialization (from INITIALIZED or RUNNING to INITIALIZED, via CONFIGURED). More...
StatusCode | restart () override
| Initialization (from RUNNING to RUNNING, via INITIALIZED). More...
Gaudi::StateMachine::State | FSMState () const override
| Get the current state. More...
Gaudi::StateMachine::State | targetFSMState () const override
| When we are in the middle of a transition, get the state where the transition is leading us. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...

## Protected Attributes
SmartIF< IInterface > | m_application
| Pointer to the owner of the manager. More...
SmartIF< IStateful > | m_stateful
| Pointer to the IStateful interface of the owner. More...
InterfaceID | m_basicInterfaceId
| Basic interface id of the managed components. More...
SmartIF< ISvcLocator > | m_svcLocator
| Service locator (needed to access the MessageSvc) More...

## Additional Inherited Members
Public Types inherited from CommonMessaging< implements< IComponentManager > >
using | base_class = CommonMessaging
Protected Member Functions inherited from CommonMessaging< implements< IComponentManager > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Detailed Description

Base class for a component manager.

Author
  Marco Clemencic

Definition at line 13 of file ComponentManager.h.

## Constructor & Destructor Documentation

ComponentManager::ComponentManager | ( | IInterface * | application,
|  | const InterfaceID & | baseIID
| ) |  |

Constructor.

Parameters

  application | the manager of managers

Definition at line 12 of file ComponentManager.cpp.

12 :
13 m_application(application), m_stateful(application), m_basicInterfaceId(baseIID)
14 {
15 }
ComponentManager::m_stateful
SmartIF< IStateful > m_stateful
Pointer to the IStateful interface of the owner.
Definition: ComponentManager.h:74
ComponentManager::m_basicInterfaceId
InterfaceID m_basicInterfaceId
Basic interface id of the managed components.
Definition: ComponentManager.h:77
ComponentManager::m_application
SmartIF< IInterface > m_application
Pointer to the owner of the manager.
Definition: ComponentManager.h:71

ComponentManager::~ComponentManager | ( |  | ) |
| override default

Virtual destructor.

## Member Function Documentation

const InterfaceID & ComponentManager::componentBaseInterface | ( |  | ) | const
| override

Basic interface id of the managed components.

Definition at line 19 of file ComponentManager.cpp.

19 {
20 return m_basicInterfaceId;
21 }
ComponentManager::m_basicInterfaceId
InterfaceID m_basicInterfaceId
Basic interface id of the managed components.
Definition: ComponentManager.h:77

StatusCode ComponentManager::configure | ( |  | ) |
| inline override

Configuration (from OFFLINE to CONFIGURED).

Definition at line 37 of file ComponentManager.h.

37 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

StatusCode ComponentManager::finalize | ( |  | ) |
| inline override

Finalize (from INITIALIZED to CONFIGURED).

Definition at line 49 of file ComponentManager.h.

49 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

Gaudi::StateMachine::State ComponentManager::FSMState | ( |  | ) | const
| inline override

Get the current state.

Definition at line 62 of file ComponentManager.h.

62 {return m_stateful->FSMState();}
ComponentManager::m_stateful
SmartIF< IStateful > m_stateful
Pointer to the IStateful interface of the owner.
Definition: ComponentManager.h:74
IStateful::FSMState
virtual Gaudi::StateMachine::State FSMState() const =0
Get the current state.

StatusCode ComponentManager::initialize | ( |  | ) |
| inline override

Initialization (from CONFIGURED to INITIALIZED).

Definition at line 40 of file ComponentManager.h.

40 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

StatusCode ComponentManager::queryInterface | ( | const InterfaceID & | iid,
|  | void ** | pinterface
| ) |  |
| override

Specialized queryInterface implementation.

If an interface is not fount in the implemented ones, we fall back on the owner.

Definition at line 25 of file ComponentManager.cpp.

26 {
27 // try local interfaces
28 StatusCode sc = base_class::queryInterface(iid,pinterface);
29 // fall back on the owner, if local interface didn't match...
30 return sc.isSuccess() ? sc : m_application->queryInterface(iid, pinterface);
31 }
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:76
merge_files.sc
int sc
Definition: merge_files.py:167
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
ComponentManager::m_application
SmartIF< IInterface > m_application
Pointer to the owner of the manager.
Definition: ComponentManager.h:71
IInterface::queryInterface
virtual StatusCode queryInterface(const InterfaceID &ti, void **pp)=0
Set the void** to the pointer to the requested interface of the instance.

StatusCode ComponentManager::reinitialize | ( |  | ) |
| inline override

Initialization (from INITIALIZED or RUNNING to INITIALIZED, via CONFIGURED).

Definition at line 56 of file ComponentManager.h.

56 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

StatusCode ComponentManager::restart | ( |  | ) |
| inline override

Initialization (from RUNNING to RUNNING, via INITIALIZED).

Definition at line 59 of file ComponentManager.h.

59 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

SmartIF<ISvcLocator>& ComponentManager::serviceLocator | ( |  | ) | const
| inline override

Definition at line 31 of file ComponentManager.h.

31 {
32 if (!m_svcLocator) m_svcLocator = m_application;
33 return m_svcLocator;
34 }
ComponentManager::m_svcLocator
SmartIF< ISvcLocator > m_svcLocator
Service locator (needed to access the MessageSvc)
Definition: ComponentManager.h:80
ComponentManager::m_application
SmartIF< IInterface > m_application
Pointer to the owner of the manager.
Definition: ComponentManager.h:71

StatusCode ComponentManager::start | ( |  | ) |
| inline override

Start (from INITIALIZED to RUNNING).

Definition at line 43 of file ComponentManager.h.

43 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

StatusCode ComponentManager::stop | ( |  | ) |
| inline override

Stop (from RUNNING to INITIALIZED).

Definition at line 46 of file ComponentManager.h.

46 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

Gaudi::StateMachine::State ComponentManager::targetFSMState | ( |  | ) | const
| inline override

When we are in the middle of a transition, get the state where the transition is leading us.

Otherwise it returns the same state as state().

Definition at line 66 of file ComponentManager.h.

66 {return m_stateful->targetFSMState();}
IStateful::targetFSMState
virtual Gaudi::StateMachine::State targetFSMState() const =0
When we are in the middle of a transition, get the state where the transition is leading us...
ComponentManager::m_stateful
SmartIF< IStateful > m_stateful
Pointer to the IStateful interface of the owner.
Definition: ComponentManager.h:74

StatusCode ComponentManager::terminate | ( |  | ) |
| inline override

Initialization (from CONFIGURED to OFFLINE).

Definition at line 52 of file ComponentManager.h.

52 {return StatusCode::SUCCESS;}
StatusCode::SUCCESS
Definition: StatusCode.h:30

## Member Data Documentation

SmartIF<IInterface> ComponentManager::m_application
| protected

Pointer to the owner of the manager.

Definition at line 71 of file ComponentManager.h.

InterfaceID ComponentManager::m_basicInterfaceId
| protected

Basic interface id of the managed components.

Definition at line 77 of file ComponentManager.h.

SmartIF<IStateful> ComponentManager::m_stateful
| protected

Pointer to the IStateful interface of the owner.

Definition at line 74 of file ComponentManager.h.

SmartIF<ISvcLocator> ComponentManager::m_svcLocator
| mutable protected

Service locator (needed to access the MessageSvc)

Definition at line 80 of file ComponentManager.h.

The documentation for this class was generated from the following files:

- GaudiKernel/GaudiKernel/ComponentManager.h
- GaudiKernel/src/Lib/ComponentManager.cpp